<?php

class Form extends Mail
{
	var $msg_err = array(); // Tableau des messages d'erreurs
	var $last_obj = ''; // Dernier objet pass en paramtre
	var $objError = array(); // Tableau des objet en erreur / permet de les signaler en javascript
	var $objErrorMsg = array(); // Tableau d'erreur pour une customisation possible
	var $custom_msg = ''; // Personnalise les messages d'erreurs
	var $formErrorLang = TPLN_LANG; // Rcupration de la langue par defaut 
	var $formName = ''; // nom du formulaire par defaut
	var $init = 0; // doit-on initialiser les donnes du formulaire
	var $row_val = array(); // contient notre tableau de valeurs
	var $error_display_mode = 'I'; // T: top ou bien I: Inline
	var $captcha = 0; // captcha activat
	var $formErrorColor = "#FF4444"; // Couleur de l'erreur
	 
	// mode d'affichage d'erreur
	function formSetDisplayMode($mode)
	{
		$this->error_display_mode = $mode;
	}
	
	// setter form name
	function formSetName($formName)
	{
		$this->formName = $formName;
	}
	
	// methode prive gnric
	// test s'il existe un message d'erreur personnalis
	function errorCustom()
	{
		// rcupere les objet en erreur pour les signal au niveau du javascript
		if(!in_array($this->last_obj, $this->objError))
		{
			$this->objError[] = $this->last_obj;
		} 

		if(!empty($this->custom_msg))
		{
			$this->msg_err[] = $this->custom_msg;
			$this->objErrorMsg[$this->last_obj][] = $this->custom_msg;

			$this->custom_msg = '';
			return true;
		} 
		else
		{
			$this->custom_msg = '';
			return false;
		} 
	} 

	function rules($obj)
	{
		if($_POST)
		{ 
			// on retire les [] qui est un tableau
			$array = false;
			$obj2 = $obj;
			if(substr($obj2, -2, 2) == '[]')
			{
				$obj2 = substr($obj2, 0, strlen($obj2)-2);
				$array = true;
			} 

			if(!isset($_POST[$obj2]))
			{
				if($array)
					$_POST[$obj2] = array(); #evite les bugs IE, FIREFOX
				else
					$_POST[$obj2] = ''; #evite les bugs IE, FIREFOX
			}
			
			if(empty($obj))$obj = $this->last_obj;
			if(empty($obj))
			{
				if($this->formErrorLang == 'fr')
					die("TPLN Form: `$obj` Aucun objet trouv");
				else
					die("TPLN Form: `$obj` No object found");
			}
			
			$this->last_obj = $obj;
			return true;
		}

		return false; # obligatoire
	} 

	function formInit($arr)
	{
		$this->init = 1;
		$this->row_val = $arr;
	} 

	function setMessage($msg) // Personnalise un message d'erreur
	{
		$this->custom_msg = $msg;
	} 

	function notEmpty($obj = '', $msg= '') // Vrifie qu'un objet n'est pas vide
	{
		if(is_array($obj))
		{
			foreach($obj as $cur_obj)
				$this->notEmpty($cur_obj);		
			return;
		}
	
		if(!$this->rules($obj))return; 
		
		if(!empty($msg))$this->setMessage($msg);		
		
		// si notEmpty est utilis sur une objet file alors fileControl est appell  la place
		if(isset($_FILES[$this->last_obj]))
		{
			$this->fileControl($this->last_obj, 1);
			return;
		} 
	
		// Deux traitement differents pour les tableau et les non-tableau
		$obj2 = str_replace('[]', '', $this->last_obj);
		$err = false;

		if(!is_array($_POST[$obj2]))
		{
			if(empty($_POST[$obj2]))
				$err = true;
		}
		elseif(count($_POST[$obj2]) == 0)
		{
			$err = true;
		}

		if($err)
		{
			if(!$this->errorCustom())
			{
				if($this->formErrorLang == 'fr')
					$msg = "Le champ '$this->last_obj' ne peut tre vide";
				else
					$msg = "Field '$this->last_obj' can not be empty";

				$this->msg_err[] = $msg;
				$this->objErrorMsg[$this->last_obj][] = $msg;
			} 
		} 
	} 

	function onlyDigit($obj = '', $float_accepted = 0)
	{
		if(!$this->rules($obj))return;

		if($float_accepted)
			$res = ereg('^[+-]?[0-9]*\.?[0-9]+$', $_POST[$this->last_obj]);
		else
			$res = ctype_digit($_POST[$this->last_obj]);

		if(!empty($_POST[$this->last_obj]) && !$res)
		{
			if(!$this->errorCustom())
			{
				if($this->formErrorLang == 'fr')
					$msg = "Le champ '$this->last_obj' ne peut contenir que des chiffres";
				else
					$msg = "Field '$this->last_obj' can only countain digit";

				$this->msg_err[] = $msg;
				$this->objErrorMsg[$this->last_obj][] = $msg;
			} 
		} 
	} 
	
	function Equal($obj = '', $value) {$this->isEqual($obj = '', $value);}
	function isEqual($obj = '', $value)
	{
		if(!$this->rules($obj))return;
		if($_POST[$this->last_obj] != $value)
		{
			if(!$this->errorCustom())
			{
				if($this->formErrorLang == 'fr')
					$msg = "Le champ '$this->last_obj' doit tre gale  '$value'";
				else
					$msg = "Field '$this->last_obj' must be equal at '$value'";
				$this->msg_err[] = $msg;
				$this->objErrorMsg[$this->last_obj][] = $msg;
			} 
		} 
	} 

	function inList($obj = '', $value) {$this->inList($obj = '', $value);}
	function isInList($obj = '', $arr_value, $case_sensitive = false)
	{		
		if(!$this->rules($obj))return;
		
		$obj = str_replace('[]', '', $obj);
		$val = $_POST[$obj];
	
		
		$arr_value_o = $arr_value;
		if(!$case_sensitive)
		{
			if(!is_array($val))
				$val = strtolower($val);
			else
				$val = array_map('strtolower', $val);
				
			$arr_value = array_map('strtolower', $arr_value);
		}
		
		$err = false;
		if(is_array($val))
		{				
			foreach($val as $v)
			{				
				if(!in_array($v, $arr_value, true))
				{
					$err = true;
					break;
				}	
			}		
		}
		else
		{
			if(!in_array($val, $arr_value, true))
			{
				$err = true;
			}	
		}
		
		
		if($err)
		{
			if(!$this->errorCustom())
			{
				$values = join(', ', $arr_value_o);
				if($this->formErrorLang == 'fr')
					$msg = "Le champ '$this->last_obj' doit tre dans la liste  '$values'";
				else
					$msg = "Field '$this->last_obj' must be in the list '$values'";
				
				$this->msg_err[] = $msg;
				$this->objErrorMsg[$this->last_obj][] = $msg;
			} 
		} 
	} 

	function onlyLetter($obj = '')
	{
		if(!$this->rules($obj))return;
		if(!ctype_alpha($_POST[$this->last_obj]))
		{
			if(!$this->errorCustom())
			{
				if($this->formErrorLang == 'fr')
					$msg = "Le champ '$this->last_obj' ne peut contenir que des lettres";
				else
					$msg = "Field '$this->last_obj' can only countain letters";
				$this->msg_err[] = $msg;
				$this->objErrorMsg[$this->last_obj][] = $msg;
			} 
		} 
	} 

	function email($obj = '')
	{
		if(!$this->rules($obj))return;
		if(!eregi("^[_\.0-9a-z-]+@([0-9a-z-]+\.)+[a-z]{2,4}$", $_POST[$this->last_obj]) && (!empty($_POST[$this->last_obj])))
		{
			if(!$this->errorCustom())
			{
				if($this->formErrorLang == 'fr')
					$msg = "Le champ '$this->last_obj' n'est pas une adresse mail valide";
				else
					$msg = "Field '$this->last_obj' is not a valid mail address";
				$this->msg_err[] = $msg;
				$this->objErrorMsg[$this->last_obj][] = $msg;
			} 
		} 
	} 

	function charLength($obj = '', $length)
	{
		if(!$this->rules($obj))return;
		if(strlen($_POST[$this->last_obj]) != $length)
		{
			if(!$this->errorCustom())
			{
				if($this->formErrorLang == 'fr')
					$msg = "Le champ '$this->last_obj' doit contenir '$length' caractres";
				else
					$msg = "Field '$this->last_obj' must contain '$length' characters";

				$this->msg_err[] = $msg;
				$this->objErrorMsg[$this->last_obj][] = $msg;
			} 
		} 
	} 

	function minLength($obj = '', $length)
	{
		if(!$this->rules($obj))return;
		if(strlen($_POST[$this->last_obj]) < $length)
		{
			if(!$this->errorCustom())
			{
				if($this->formErrorLang == 'fr')
					$msg = "Le champ '$this->last_obj' doit contenir au moins '$length' caractres";
				else
					$msg = "Field '$this->last_obj' must contain at least '$length' characters";

				$this->msg_err[] = $msg;
				$this->objErrorMsg[$this->last_obj][] = $msg;
			}
		} 
	} 

	function maxLength($obj = '', $length)
	{
		if(!$this->rules($obj))return;
		if(strlen($_POST[$this->last_obj]) > $length)
		{
			if(!$this->errorCustom())
			{
				if($this->formErrorLang == 'fr')
					$msg = "Le champ '$this->last_obj' doit contenir au maximum '$length' caractres";
				else
					$msg = "Field '$this->last_obj' must contain '$length' characters maximum";

				$this->msg_err[] = $msg;
				$this->objErrorMsg[$this->last_obj][] = $msg;
			} 
		} 
	} 

	function regexControl($pattern, $obj = '', $mess)
	{
		if(!$this->rules($obj))return;
		if(is_array($_POST[$this->last_obj]) || (!empty($_POST[$this->last_obj]) && !eregi($pattern, $_POST[$this->last_obj])))
		{
			$this->setMessage($mess);
			$this->errorCustom();
		} 
	}
	
	function Alpha($obj, $except = '')
	{
		// Vrifie si l'obj est pass en parametre, par defaut ou manquant
		if(!$this->rules($obj)) return;

		if($this->formErrorLang == 'fr')
			$mess = "Le champ '$this->last_obj' contient des caractres non alphabtique";
		else
			$mess = "Field '$this->last_obj' countains non alphabetic characters";

		$pattern = '[[:alpha:]]';
		if(!empty($except))
		{
			$tmp_pattern = preg_quote($except);
			$pattern = '('.$pattern.'|'.$tmp_pattern.')';
		}
				
		$this->regexControl('^'.$pattern.'*$', $obj, $mess);
				
	}

	function AlphaNumeric($obj, $except = '')
	{
		// Vrifie si l'obj est pass en parametre, par defaut ou manquant
		if(!$this->rules($obj)) return;

		if($this->formErrorLang == 'fr')
			$mess = "Le champ '$this->last_obj' contient des caractres non alphanumrique";
		else
			$mess = "Field '$this->last_obj' countains non alphanumeric characters";

		$pattern = '[[:alnum:]]';
		if(!empty($except))
		{
			$tmp_pattern = preg_quote($except);
			$pattern = '('.$pattern.'|'.$tmp_pattern.')';
		}
				
		$this->regexControl('^'.$pattern.'*$', $obj, $mess);
				
	}	
	
	

	function Date($obj, $format){$this->isDate($obj, $format);}
	function isDate($obj, $format)
	{ 
		// Vrifie si l'obj est pass en parametre, par defaut ou manquant
		if(!$this->rules($obj)) return;
		
		$pattern = $format;
		$pattern = str_replace('d', '[0-9]{2}', $pattern);
		$pattern = str_replace('m', '[0-9]{2}', $pattern);
		$pattern = str_replace('y', '[0-9]{2}', $pattern);
		$pattern = str_replace('Y', '[0-9]{4}', $pattern);

		$pattern = str_replace('H', '[0-9]{2}', $pattern);
		$pattern = str_replace('i', '[0-9]{2}', $pattern);
		$pattern = str_replace('s', '[0-9]{2}', $pattern);

		$pattern = "^$pattern$";

		if($this->formErrorLang == 'fr')
			$mess = "Le champ '$this->last_obj' n'est pas une date valide , format autoris $format";
		else
			$mess = "Field '$this->last_obj' is not a valid date, format allowed $format";

		$this->regexControl($pattern, $obj, $mess);
	} 

	function Url($obj, $format = 'http://|https://|ftp://')
	{ 
		// Vrifie si l'obj est pass en parametre, par defaut ou manquant
		if(!$this->rules($obj)) return;
		$format2 = str_replace('/', '\/', $format);
		$pattern = "^($format2){0,1}[A-Za-z0-9][A-Za-z0-9\-\.]+[A-Za-z0-9]\.[A-Za-z]{2,}[\43-\176]*$";

		if($this->formErrorLang == 'fr')
			$mess = "Le champ '$this->last_obj' n'est pas une url valide";
		else
			$mess = "Field '$this->last_obj' is not a valid url";

		$this->regexControl($pattern, $obj, $mess);
	} 

	function fileControl($obj, $required = '', $taille = '', $mimes = '', $ext = '')
	{ 
		// Vrifie si l'obj est pass en parametre, par defaut ou manquant
		if(!$this->rules($obj)) return; 
		// vrifie que lors de l'upload l'objet controler est bien du type upload
		if($_FILES)
		{
			if(empty($_FILES[$this->last_obj]))
			{ 
				// Erreur les argument sont bien manquant
				if($this->formErrorLang == 'fr')
					die("<b>Erreur</b> : La restriction <b>fileControl</b> peut pas controler l'objet <b>$obj</b> <br> ou alors l'objet <b>$obj</b> n'existe pas");
				else
					die("<b>Error</b> :  The restriction <b>fileControl</b> cannot control the object <b>$obj</b> or then the <b>$obj</b> object does not exist");
			} 
			// Control de prsence
			if(!is_uploaded_file($_FILES[$this->last_obj]['tmp_name']))
			{
				if(!empty($required))
				{
					if(!$this->errorCustom())
					{
						if($this->formErrorLang == 'fr')
							$msg = "Le champ '$this->last_obj' doit tre rempli";
						else
							$msg = "Field '$this->last_obj' cannot be empty";

						$this->msg_err[] = $msg;
						$this->objErrorMsg[$this->last_obj][] = $msg;
					} 
				} 
				return;
			} 

			// Control de la taille maximum du fichier
			if(!empty($taille) && !is_int($taille))
			{ 
				// on replace Ko et Mo
				$taille = strtolower($taille);
				$taille = str_replace(' ', '', $taille);
				$taille = str_replace('ko', '*1024', $taille);
				$taille = str_replace('mo', '*1024*1024', $taille);
				eval("\$taille = $taille;");
			} 

			if(!empty($taille) && ($_FILES[$this->last_obj]['size'] > $taille))
			{
				if(!$this->errorCustom())
				{
					if($this->formErrorLang == 'fr')
						$msg = "$this->last_obj: La taille du fichier {$_FILES[$this->last_obj]['name']} dpasse la taille maximum autorise qui est de '$taille'";
					else
						$msg = "$this->last_obj: he {$_FILES[$this->last_obj]['name']} 's file size is over than the allowed's maximum size which is '$taille'";

					$this->msg_err[] = $msg;
					$this->objErrorMsg[$this->last_obj][] = $msg;
				} 
			} 

			// verification de l'extension
			$ext_arr = explode(',', $ext);
			$ext_arr = array_map('trim', $ext_arr);
			$ext_arr = array_map('strtolower', $ext_arr);
			
			// on prend l'extension du fichier
			@ereg("\.([^\.]*$)", $_FILES[$this->last_obj]['name'], $elts);

			if(!empty($ext) && (count($elts) == 0 || !in_array(strtolower($elts[1]), $ext_arr)))
			{
				if(!$this->errorCustom())
				{
					if($this->formErrorLang == 'fr')
						$msg = "$this->last_obj: L'extension du fichier {$_FILES[$this->last_obj]['name']} n'est pas autoris, seulement '$ext'";
					else
						$msg = "$this->last_obj: The extension of file {$_FILES[$this->last_obj]['name']} is not allowed, only '$ext'";

					$this->msg_err[] = $msg;
					$this->objErrorMsg[$this->last_obj][] = $msg;
				} 
			} 

			// Control MIME du type de fichier
			$mimes_arr = explode(',', $mimes);
			$mimes_arr = array_map('trim', $mimes_arr);
			$mimes_arr = array_map('strtolower', $mimes_arr);

			if(!empty($mimes) && !in_array(strtolower($_FILES[$this->last_obj]['type']), $mimes_arr))
			{
				if(!$this->errorCustom())
				{
					if($this->formErrorLang == 'fr')
						$msg = "$this->last_obj: Le type MIME `{$_FILES[$this->last_obj]['type']}` de votre fichier {$_FILES[$this->last_obj]['name']} n'est pas autoris, seulement '$mimes'";
					else
						$msg = "$this->last_obj: The MIME type `{$_FILES[$this->last_obj]['type']}` of {$_FILES[$this->last_obj]['name']} is not allowed, only '$mimes'";

					$this->msg_err[] = $msg;
					$this->objErrorMsg[$this->last_obj][] = $msg;
				} 
			} 
		} 
	} 

	// Cette methode permet de slectionne la langue dans laquelle vont tre afficher les erreurs
	function formSetLang($lang)
	{
		$this->formErrorLang = $lang;
	} 

	// Ajoute l'objet pass en parametre  l'ensemble des objet erreur
	function addError($obj = '', $message = '')
	{
		if(!$this->rules($obj))return;

		if(!empty($message))
		{
			if(!$this->errorCustom())
			{
				$msg = $message;
				$this->msg_err[] = $message;
			} 
		} 
		else
		{
			if(!$this->errorCustom())
			{
				if($this->formErrorLang == 'fr')
					$msg = "";
				else
					$msg = "";
			} 
		} 

		$this->msg_err[] = $msg;
		$this->objErrorMsg[$this->last_obj][] = $msg;
	} 

	// Controle la taille d'une image
	function imgStrictDimension($obj = '', $w = '', $h = '')
	{ 
		// Vrifie si l'obj est pass en parametre, par defaut ou manquant
		if(!$this->rules($obj)) return; 
		// Vrifie qu'il existe au moins une restriction
		if((empty($w)) && (empty($h)))
		{ 
			// Erreur les argument sont bien manquant
			if($this->formErrorLang == 'fr')
				die("Argument manquant sur la methode imgStrictDimension contolant l'objet $this->last_obj ");
			else
				die("Argument missing on the method imgStrictDimension controling the $this->last_obj object");
		} 
		else // Au moins 1 argument existe
		{
			// vrifie que lors de l'upload l'objet controler est bien du type upload
			if($_FILES)
			{
				if(!isset($_FILES[$this->last_obj]))
				{ 
					// Erreur l'objet est mauvais
					if($this->formErrorLang == 'fr')
						die("Erreur : La restriction imgStrictDimension peut pas controler l'objet $this->last_obj ou alors l'objet $this->last_obj n'existe pas");
					else
						die("Error :  The restriction imgStrictDimension cannot control the object $this->last_obj or then the $this->last_obj object does not exist");
				} 
			} 

			// Si l'on upload une image et si l'image existe
			if(($_FILES) && 
			   (eregi('^image/', $_FILES[$this->last_obj]['type'])) && # ,que le type est image
			   ($dimension = getimagesize($_FILES[$this->last_obj]['tmp_name'])) # et que l'image existe
			)
			{ 
				// test de largeur
				if(!empty($w) && ($w != $dimension[0]))
				{
					if(!$this->errorCustom()) # l'on regard si l'erreur a dj t rfrenc
					{
						if($this->formErrorLang == 'fr') # on slectionne la langue
						{
							if(($dimension[0] - $w) > 0) # calcul des diffrences
								$relation = 'grande';
							else
								$relation = 'petite';
	
							$msg = "La largeur de l'image {$_FILES[$this->last_obj]['name']} est trop $relation de " . abs($dimension[0] - $w) . " pixels (autoris $w px)";
						} 
						else
						{
							if(($dimension[0] - $w) > 0)
								$relation = 'big';
							else
								$relation = 'small';
	
							$msg = "The width of the image {$_FILES[$this->last_obj]['name']}  is too $relation by " . abs($dimension[0] - $w) . " pixels (allowed $w px)";
						} 
	
						$this->msg_err[] = $msg;
						$this->objErrorMsg[$this->last_obj][] = $msg;
					} 
				} 
						
				// test de hauteur
				if(!empty($h) && ($h != $dimension[1]))
				{
					if(!$this->errorCustom())
					{
						if($this->formErrorLang == 'fr')
						{
							if(($dimension[1] - $h) > 0)
								$relation = 'grande';
							else
								$relation = 'petite';
		
							$msg = "La hauteur de l'image {$_FILES[$this->last_obj]['name']} est trop $relation de " . abs($dimension[1] - $h) . " pixels (autoris $h px)";
						} 
						else
						{
							if(($dimension[1] - $h) > 0)
								$relation = 'big';
							else
								$relation = 'small';
		
							$msg = "The height of the image {$_FILES[$this->last_obj]['name']}  is too $relation by " . abs($dimension[1] - $h) . " pixels (allowed $h px)";
						} 
									
						$this->msg_err[] = $msg;
						$this->objErrorMsg[$this->last_obj][] = $msg;
					} 
				} 
			} 
		} 
	} 
		
	// image largeur ?
	function imgControlWidth($obj = '', $operator, $width)
	{ 
		// Vrifie si l'obj est pass en parametre, par defaut ou manquant
		if(!$this->rules($obj)) return; 
		
		// Vrifie qu'il existe au moins une restriction
		if(!in_array($operator, array('<', '<=', '=', '>', '>=')))
		{ 
			// Erreur les argument sont bien manquant
			if($this->formErrorLang == 'fr')
				die("Operateur non valide sur la methode imgControlWidth controlant l'objet $this->last_obj ");
			else
				die("Operator not valid on method imgControlWidth controling the $this->last_obj object");
		} 
		
		if(!is_int($width))
		{
			if($this->formErrorLang == 'fr')
				die("Largeur non valide sur la methode imgControlWidth controlant l'objet $this->last_obj ");
			else
				die("Width not valid on method imgControlWidth controling the $this->last_obj object");
		} 
		
		// vrifie que lors de l'upload l'objet controler est bien du type upload
		if($_FILES)
		{
			if(!isset($_FILES[$this->last_obj]))
			{ 
				// Erreur l'objet est mauvais
				if($this->formErrorLang == 'fr')
					die("Erreur : La restriction imgControlWidth peut pas controler l'objet $this->last_obj ou alors l'objet $this->last_obj n'existe pas");
				else
					die("Error :  The restriction imgControlWidth can not control the object $this->last_obj or then the $this->last_obj object does not exist");
			} 
		}
		
		// Si l'on upload une image et si l'image existe
		if(($_FILES) && # si on upload
				(eregi('^image/', $_FILES[$this->last_obj]['type'])) && # ,que le type est image
				($dimension = getimagesize($_FILES[$this->last_obj]['tmp_name'])) # et que l'image existe
				)
		{ 
			// test de largeur
			$res = false;

			if($operator == '<' && $dimension[0] < $width)$res = true;
			elseif($operator == '<=' && $dimension[0] <= $width)$res = true;
			elseif($operator == '=' && $dimension[0] = $width)$res = true;
			elseif($operator == '>' && $dimension[0] > $width)$res = true;
			elseif($operator == '>=' && $dimension[0] >= $width)$res = true;

			if(!$res)
			{
				if(!$this->errorCustom()) # l'on regard si l'erreur a dj t rfrenc
				{
					if($this->formErrorLang == 'fr') # on slectionne la langue
						$msg = "La largeur de l'image {$_FILES[$this->last_obj]['name']} doit tre $operator  $width pixels";
					else
						$msg = "The width of the image {$_FILES[$this->last_obj]['name']}  must be $operator at $width pixels";

					$this->msg_err[] = $msg;
					$this->objErrorMsg[$this->last_obj][] = $msg;
				} 
			} 
		} 
	}
	
	// image largeur ?
	function imgControlHeight($obj = '', $operator, $width)
	{ 
		// Vrifie si l'obj est pass en parametre, par defaut ou manquant
		if(!$this->rules($obj)) return; 
		// Vrifie qu'il existe au moins une restriction
		if(!in_array($operator, array('<', '<=', '=', '>', '>=')))
		{ 
			// Erreur les argument sont bien manquant
			if($this->formErrorLang == 'fr')
				die("Operateur non valide sur la methode imgControlWidth controlant l'objet $this->last_obj ");
			else
				die("Operator not valid on method imgControlWidth controling the $this->last_obj object");
		} 

		if(!is_int($width))
		{
			if($this->formErrorLang == 'fr')
				die("Hauteur non valide sur la methode imgControlWidth controlant l'objet $this->last_obj ");
			else
				die("Height not valid on method imgControlWidth controling the $this->last_obj object");
		} 
		// vrifie que lors de l'upload l'objet controler est bien du type upload
		if($_FILES)
		{
			if(!isset($_FILES[$this->last_obj]))
			{ 
				// Erreur l'objet est mauvais
				if($this->formErrorLang == 'fr')
					die("Erreur : La restriction imgControlHeight peut pas controler l'objet $this->last_obj ou alors l'objet $this->last_obj n'existe pas");
				else
					die("Error :  The restriction imgControlHeight can not control the object $this->last_obj or then the $this->last_obj object does not exist");
			} 
		} 
		// Si l'on upload une image et si l'image existe
		if(($_FILES) && # si on upload
				(eregi('^image/', $_FILES[$this->last_obj]['type'])) && # ,que le type est image
				($dimension = getimagesize($_FILES[$this->last_obj]['tmp_name'])) # et que l'image existe
				)
		{ 
			// test de largeur
			$res = false;

			if($operator == '<' && $dimension[1] < $width)$res = true;
			elseif($operator == '<=' && $dimension[1] <= $width)$res = true;
			elseif($operator == '=' && $dimension[1] = $width)$res = true;
			elseif($operator == '>' && $dimension[1] > $width)$res = true;
			elseif($operator == '>=' && $dimension[1] >= $width)$res = true;

			if(!$res)
			{
				if(!$this->errorCustom()) # l'on regard si l'erreur a dj t rfrenc
				{
					if($this->formErrorLang == 'fr') # on slectionne la langue
						$msg = "La Hauteur de l'image {$_FILES[$this->last_obj]['name']} doit tre $operator  $width pixels";
					else
						$msg = "The Height of the image {$_FILES[$this->last_obj]['name']}  must be $operator at $width pixels";

					$this->msg_err[] = $msg;
					$this->objErrorMsg[$this->last_obj][] = $msg;
				} 
			} 
		} 
	}
		
	// traitement de notre formulkaire directement en PHP
	function formParse($elements, $source)
	{
		$errs = array_keys($this->objErrorMsg); 
		// on capture le formulaire en question
		if(empty($this->formName))
			$motif = "<form [^>]* [^>]*>(.*)<\/form>";
		else
			$motif = "<form [^>]* name=\"$this->formName\"[^>]*>(.*)<\/form>";

		preg_match("/$motif/misU", $source, $arr);
		$form_init = $arr[0];
		$form_html = $arr[1];
		
		// on prend toutes les inputs
		$inputs['__ALL'] = array();
		$motif = "<input[^>]*>";
		if(preg_match_all("/$motif/i", $form_html, $arr))
			$inputs['__ALL'] = $arr[0]; 
		
		// on prend tous les attributs
		$_inputs = array(); // contient le nom des inputs
		for($i = 0; $i < count($inputs['__ALL']); $i++)
		{ 
			// on prend le nom
			$name = $this->extractStr($inputs['__ALL'][$i], 'name="', '"');
			$type = $this->extractStr($inputs['__ALL'][$i], 'type="', '"');

			$value_set = false;
			if(strpos($inputs['__ALL'][$i], 'value="') !== false)
				$value_set = true;
			$value = $this->extractStr($inputs['__ALL'][$i], 'value="', '"');

			$style_set = false;
			if(strpos($inputs['__ALL'][$i], 'style="') !== false)
				$style_set = true;
			$style = $this->extractStr($inputs['__ALL'][$i], 'style="', '"');

			$xhtml = false;
			if($inputs['__ALL'][$i][strlen($inputs['__ALL'][$i])-2] == '/')$xhtml = true; 
			// on ajoute l'input
			if(!empty($name))
			{
				if(!in_array($name, $_inputs))$_inputs[] = $name;
				$a = array('type' => $type, 'value_set' => $value_set, 'value' => $value, 'style_set' => $style_set, 'style' => $style, 'xhtml' => $xhtml, 'html' => $inputs['__ALL'][$i]);
				$input[$name][] = $a;
			} 
		} 
		
		// on prend toutes les select
		$selects['__ALL'] = array();
		$motif = "<select[^>]*>(.*)<\/select>";
		if(preg_match_all("/$motif/misU", $form_html, $arr))
			$selects['__ALL'] = $arr[0]; 
		
		// on prend tous les attributs
		$_selects = array(); // contient le nom des select
		for($i = 0; $i < count($selects['__ALL']); $i++)
		{ 
			// on prend le nom
			$name = $this->extractStr($selects['__ALL'][$i], 'name="', '"');

			$style_set = false;
			if(strpos($selects['__ALL'][$i], 'style="') !== false)
				$style_set = true;
			$style = $this->extractStr($selects['__ALL'][$i], 'style="', '"'); 
			// on prend le style des options et valeurs
			$motif = "<option[^>]*>(.*)<\/option>";
			if(preg_match_all("/$motif/im", $selects['__ALL'][$i], $arr))
				$options['__ALL'] = array();
			$options['__ALL'] = $arr[0];
			$option = array();
			for($j = 0; $j < count($options['__ALL']); $j++)
			{
				$value_op = $this->extractStr($options['__ALL'][$j], 'value="', '"');

				$style_op_set = false;
				if(strpos($options['__ALL'][$j], 'style="') !== false)
					$style_op_set = true;

				$style_op = $this->extractStr($options['__ALL'][$j], 'style="', '"');
				$option[] = array('value' => $value_op, 'style_set' => $style_op_set, 'style' => $style_op, 'html' => $options['__ALL'][$j], 'parsed' => $options['__ALL'][$j]);
			}
			
			// on ajoute le select
			if(!empty($name))
			{
				if(!in_array($name, $_selects))$_selects[] = $name;
				$select[$name][] = array('style' => $style, 'style_set' => $style_set, 'option' => $option, 'html' => $selects['__ALL'][$i]);
			} 
		}
		
		// on prend les textarea
		$textareas['__ALL'] = array();
		$motif = "<textarea[^>]*>(.*)<\/textarea>";
		if(preg_match_all("/$motif/misU", $form_html, $arr))
			$textareas['__ALL'] = $arr[0]; 
		
		// on prend tous les attributs
		$_textareas = array(); // contient le nom des select
		for($i = 0; $i < count($textareas['__ALL']); $i++)
		{ 
			// on prend le nom
			$name = $this->extractStr($textareas['__ALL'][$i], 'name="', '"');

			$style_set = false;
			if(strpos($textareas['__ALL'][$i], 'style="') !== false)
				$style_set = true;
			$style = $this->extractStr($textareas['__ALL'][$i], 'style="', '"');

			$value = $this->extractStr($textareas['__ALL'][$i], '>', '</textarea>'); 
			// on ajoute l'input
			if(!empty($name))
			{
				if(!in_array($name, $_textareas))$_textareas[] = $name;
				$textarea[$name][] = array('value' => $value, 'style_set' => $style_set, 'style' => $style, 'html' => $textareas['__ALL'][$i]);
			} 
		} 
		
		// on assigne nos valeurs ***************************************************************************
		$form_parsed = $form_init;
		$border_color = "border:1px solid ".$this->formErrorColor.";";
		$bg_color = "background-color:".$this->formErrorColor.";";

		foreach($elements as $key => $val)
		{
			$name = $key;
			$name_init = $key;
			$multiple_values = false;
			$values = array();
			if(is_array($elements[$key]))
			{
				$multiple_values = true;
				$name = $name . '[]';
			}
			
			// input ?
			if(in_array($name, $_inputs))
			{
				if(in_array($input[$name][0]['type'], array('text', 'hidden', 'password', 'file')))
				{
					$t = $input[$name][0]['html']; 
					// value existante ou non ?
					if(!$input[$name][0]['value_set'])
					{ 
						// XHTML ?
						if($input[$name][0]['xhtml'])
							$t = str_replace('/>', ' value="' . $val . '" />', $t);
						else
							$t = str_replace('>', ' value="' . $val . '">', $t);
					} 
					else
					{
						$t = str_replace('value="' . $input[$name][0]['value'] . '"', ' value="' . $val . '"', $t);
					} 
					// erreur sur input text ? ****************************************************************************
					if(in_array($name, $errs) && ($input[$name][0]['type'] == 'text' || $input[$name][0]['type'] == 'password' || $input[$name][0]['type'] == 'file'))
					{
						$t2 = '';
						if($this->error_display_mode == 'I')
						{
							$t2 = '<span style="color:'.$this->formErrorColor.'; font-weight:bold;">';
							for($j = 0; $j < count($this->objErrorMsg[$name]); $j++)
							{
								$t2 .= $this->objErrorMsg[$name][$j];
								$t2 .= '<br>';
							} 
							$t2 .= "</span>";
						} 

						$style = trim($input[$name][0]['style']);
						if(!empty($style) && $style[strlen($style)-1] != ';')$style .= '; '; 
						// Style  placer ?
						if(!$input[$name][0]['style_set'])
						{
							if($input[$name][0]['xhtml'])
								$t = str_replace(' />', ' style="' . $border_color . '" />', $t);
							else
								$t = str_replace('>', ' style="' . $border_color . '" >', $t);
						} 
						else
						{
							if($input[$name][0]['xhtml'])
								$t = str_replace(' style="' . $input[$name][0]['style'] . '"', ' style="' . $style . $border_color . '"', $t);
							else
								$t = str_replace(' style="' . $input[$name][0]['style'] . '"', ' style="' . $style . $border_color . '"', $t);
						} 
						$t = $t2 . $t;
					} 
					// *******************************************************************************************
					$form_parsed = str_replace($input[$name][0]['html'], $t, $form_parsed);
				} 
				// radio
				elseif($input[$name][0]['type'] == 'radio')
				{ 
					// groupe de radio ayant le mme nom
					for($i = 0; $i < count($input[$name]); $i++)
					{
						$t = $input[$name][$i]['html'];

						if($input[$name][$i]['value'] == $val)
						{
							if(strpos($input[$name][$i]['html'], ' checked') === false)
							{ 
								// XHTML ?
								if($input[$name][$i]['xhtml'])
									$t = str_replace(' />', ' checked />', $t);
								else
									$t = str_replace('>', ' checked >', $t);
							} 
						} 
						else // on retire le checked
							{
								$t = str_replace(' checked', ' ', $t);
						} 
						// erreur sur radio ? ****************************************************************************
						if(in_array($name, $errs))
						{
							$t2 = '';
							if($i == 0 && $this->error_display_mode == 'I')
							{
								$t2 = '<span style="color:'.$this->formErrorColor.'; font-weight:bold;">';
								for($k = 0; $k < count($this->objErrorMsg[$name]); $k++)
								{
									if($k > 0)$t .= '';
									$t2 .= $this->objErrorMsg[$name][$k] . '<br />';
								} 
								$t2 .= "</span>";
							} 

							$style = trim($input[$name][$i]['style']);
							if(!empty($style) && $style[strlen($style)-1] != ';')$style .= '; '; 
							// Style  placer ?
							if(!$input[$name][$i]['style_set'])
							{
								if($input[$name][$i]['xhtml'])
									$t = str_replace(' />', ' style="' . $border_color . '" />', $t);
								else
									$t = str_replace('>', ' style="' . $border_color . '" >', $t);
							} 
							else
							{
								if($input[$name][$i]['xhtml'])
									$t = str_replace(' style="' . $input[$name][$i]['style'] . '"', ' style="' . $style . $border_color . '"', $t);
								else
									$t = str_replace(' style="' . $input[$name][$i]['style'] . '"', ' style="' . $style . $border_color . '"', $t);
							} 
							$t = $t2 . $t;
						} 
						// *******************************************************************************************
						$form_parsed = $this->str_replace_count($input[$name][$i]['html'], $t, $form_parsed, 1);
					} 
				} // checkbox simple
				elseif($input[$name][0]['type'] == 'checkbox')
				{ 
					// valeurs multiples ?
					if($multiple_values)
					{
						$values = array();
						for($j = 0; $j < count($elements[$name_init]); $j++)
						$values[] = $elements[$name_init][$j];
					}
					
					// groupe de checkbox ayant le meme nom
					for($i = 0; $i < count($input[$name]); $i++)
					{
						$t = $input[$name][$i]['html'];
						if((!$multiple_values && $input[$name][$i]['value'] == $val) || ($multiple_values && in_array($input[$name][$i]['value'], $values)))
						{
							if(strpos($input[$name][$i]['html'], ' checked') === false)
							{ 
								// XHTML ?
								if($input[$name][$i]['xhtml'])
									$t = str_replace(' />', ' checked />', $t);
								else
									$t = str_replace('>', ' checked >', $t);
							} 
						} 
						else // on retire le checked
						{
								$t = str_replace(' checked', ' ', $t);
						}
						
						// erreur sur checkbox ? ****************************************************************************
						if(in_array($name, $errs))
						{
							$t2 = '';
							if($i == 0 && $this->error_display_mode == 'I')
							{
								$t2 = '<span style="color:'.$this->formErrorColor.'; font-weight:bold;">';
								for($k = 0; $k < count($this->objErrorMsg[$name]); $k++)
								{
									if($k > 0)$t .= '';
									$t2 .= $this->objErrorMsg[$name][$k] . '<br />';
								} 
								$t2 .= "</span>";
							} 

							$style = trim($input[$name][$i]['style']);
							if(!empty($style) && $style[strlen($style)-1] != ';')$style .= '; '; 
							// Style  placer ?
							if(!$input[$name][$i]['style_set'])
							{
								if($input[$name][$i]['xhtml'])
									$t = str_replace(' />', ' style="' . $border_color . '" />', $t);
								else
									$t = str_replace('>', ' style="' . $border_color . '" >', $t);
							} 
							else
							{
								if($input[$name][$i]['xhtml'])
									$t = str_replace(' style="' . $input[$name][$i]['style'] . '"', ' style="' . $style . $border_color . '"', $t);
								else
									$t = str_replace(' style="' . $input[$name][$i]['style'] . '"', ' style="' . $style . $border_color . '"', $t);
							} 
							$t = $t2 . $t;
						} 
						// *******************************************************************************************
						$form_parsed = $this->str_replace_count($input[$name][$i]['html'], $t, $form_parsed, 1);
					} 
				} 
			} 
			// textarea ?
			elseif(in_array($name, $_textareas))
			{
				$t = $textarea[$name][0]['html'];
				$t = str_replace('>' . $textarea[$name][0]['value'] . '</textarea>', '>' . $val . '</textarea>', $t); 
				
				// erreur sur textarea ? ****************************************************************************
				if(in_array($name, $errs))
				{
					$style = trim($textarea[$name][0]['style']);
					if(!empty($style) && $style[strlen($style)-1] != ';')$style .= '; '; 
					// Style  placer ?
					if(!$textarea[$name][0]['style_set'])
						$t = $this->str_replace_count('>', ' style="' . $border_color . '" >', $t, 1);
					else
						$t = $this->str_replace_count(' style="' . $textarea[$name][0]['style'] . '"', ' style="' . $style . $border_color . '"', $t, 1);

					if($this->error_display_mode == 'I')
					{
						$t2 = '<span style="color:'.$this->formErrorColor.'; font-weight:bold;">';
						for($j = 0; $j < count($this->objErrorMsg[$name]); $j++)
						{
							$t2 .= $this->objErrorMsg[$name][$j];
							$t2 .= '<br />';
						} 
						$t2 .= "</span>";
						$t = $t2 . $t;
					} 
				} 
				// *******************************************************************************************
				$form_parsed = str_replace($textarea[$name][0]['html'], $t, $form_parsed);
			} 
			// select ?
			elseif(in_array($name, $_selects))
			{ 
				// select simple && multiple
				for($i = 0; $i < count($select[$name]); $i++)
				{ 
					// valeurs multiples ?
					if($multiple_values)
					{
						$values = array();
						for($j = 0; $j < count($elements[$name_init]); $j++)
						$values[] = $elements[$name_init][$j];
					} 
					// selected
					for($j = 0; $j < count($select[$name][$i]['option']); $j++)
					{
						if((!$multiple_values && $select[$name][$i]['option'][$j]['value'] == $val) || ($multiple_values && in_array($select[$name][$i]['option'][$j]['value'], $values)))
						{
							if(strpos($select[$name][$i]['option'][$j]['html'], ' selected') === false)
								$select[$name][$i]['option'][$j]['parsed'] = $this->str_replace_count('>', ' selected>', $select[$name][$i]['option'][$j]['html'], 1);
						} 
						else // on efface le selected
						{
							$select[$name][$i]['option'][$j]['parsed'] = $this->str_replace_count(' selected', ' ', $select[$name][$i]['option'][$j]['html'], 1);
						} 
					} 
					// on remplace le bon select
					$t = $select[$name][$i]['html'];
					for($j = 0; $j < count($select[$name][$i]['option']); $j++)
					$t = $this->str_replace_count($select[$name][$i]['option'][$j]['html'], $select[$name][$i]['option'][$j]['parsed'], $t, 1); 
					
					// erreur sur select ? ****************************************************************************
					if(in_array($name, $errs))
					{
						$style = trim($select[$name][$i]['style']);
						if(!empty($style) && $style[strlen($style)-1] != ';')$style .= '; '; 
						// Style  placer ?
						if(!$select[$name][$i]['style_set'])
							$t = $this->str_replace_count('>', ' style="' . $bg_color . '" >', $t, 1);
						else
							$t = $this->str_replace_count(' style="' . $select[$name][$i]['style'] . '"', ' style="' . $style . $bg_color . '"', $t, 1);

						if($this->error_display_mode == 'I')
						{
							$t2 = '<span style="color:'.$this->formErrorColor.'; font-weight:bold;">';
							for($j = 0; $j < count($this->objErrorMsg[$name]); $j++)
							{
								$t2 .= $this->objErrorMsg[$name][$j] . '<br />';
							} 
							$t2 .= "</span>";
							$t = $t2 . $t;
						} 
					} 
					// *******************************************************************************************
					$form_parsed = str_replace($select[$name][$i]['html'], $t, $form_parsed);
				} 
			} 
		} 

		return $form_parsed;
	}
	
	function formGetTotalError()
	{
		return count(array_merge(array_unique($this->msg_err), array()));
	}

	function formIsValid() // dtruit le bloc error s'il n'y a pas de post
	{
		// verification du captcha
		if($this->captcha)
			$this->autoVerifyCaptcha();
		
		// on capture le formulaire en question
		if(empty($this->formName))
			$motif = "<form [^>]* [^>]*>(.*)<\/form>";
		else
			$motif = "<form [^>]* name=\"$this->formName\"[^>]*>(.*)<\/form>";
		preg_match("/$motif/imsU", $this->f[$this->f_no]['buffer'], $arr);
		$form_html = $arr[0];

		if(!$_POST)
		{ 
			// on regarde si le bloc form contienr form_error
			$form_error_inside = false;
			if(strpos($form_html, '<bloc::form_error>') !== false)
				$form_error_inside = true;

			if($this->init)
			{
				$form_parsed = $this->formParse($this->row_val, $this->f[$this->f_no]['buffer']);
				$this->f[$this->f_no]['buffer'] = str_replace($form_html, $form_parsed, $this->f[$this->f_no]['buffer']);
			} 
			
			// if($form_error_inside && $this->blocExists('form_error'))
			if($this->blocExists('form_error'))
				$this->EraseBloc('form_error');

			if($this->blocExists('form_valid'))
				$this->EraseBloc('form_valid');
		} 
		else
		{
			if(count($this->msg_err) > 0)
			{ 
				// traitements des erreurs
				$form_parsed = $this->formParse($_POST, $this->f[$this->f_no]['buffer']);
				$this->f[$this->f_no]['buffer'] = str_replace($form_html, $form_parsed, $this->f[$this->f_no]['buffer']); 
				
				// form valide ?
				if($this->blocExists('form_valid'))
					$this->EraseBloc('form_valid'); 
				
				// Codage html de la sortie des messages d'erreur
				// $this->msg_err = array_unique($this->msg_err);
				$this->msg_err = array_merge(array_unique($this->msg_err), array());
				
				foreach($this->msg_err as $key => $val)
					$this->msg_err[$key] = htmlentities($val);

				if($this->error_display_mode == 'T')
				{
					for($i = 0; $i < count($this->msg_err); $i++)
					{
						$m = $this->msg_err[$i];

						if(!empty($m))
						{
							$this->Parse('form_error.msg', $m);
							$this->Loop('form_error');
						} 
					} 
				} 
				elseif($this->error_display_mode == 'I')
				{
					if($this->blocExists('form_error'))
						$this->EraseBloc('form_error');
				}

				return false;
			} 
			else
			{
				$form_error_inside_form = false;
				if($this->blocExists('form_valid'))
				{
					$f_v = $this->GetBlocInFile('form_valid'); 
					// on regarde si le bloc form:error est dans le form
					if(strpos($form_html, '<bloc::form_error>') !== false)$form_error_inside_form = true; 
					// on remplace directement dans le buffer
					$this->f[$this->f_no]['buffer'] = str_replace($form_html, $f_v, $this->f[$this->f_no]['buffer']);
				} 
				
				// bloc form_error en dehors automatiquement remplac
				if(!$form_error_inside_form && $this->blocExists('form_error'))
					$this->EraseBloc('form_error');
				
				if($this->blocExists('form_valid'))
					$this->EraseBloc('form_valid');

				// on supprime les valeurs du captcha
				$this->_delCaptcha();				

				return true;
			}
		}
	}
	
	// CAPTCHA *********************************************************************************************************
	function getCaptcha()
	{
		$this->captcha = 1;
		
		// on gnre le numero id
		if(!$_POST)$this->generateCaptcha();
		
		$sn = session_name();
		$sn  = ($sn == 'PHPSESSID') ? '' : '?sn='.base64_encode($sn);
		$str = '<img src="'.TPLN_WEB_PATH.'/plugin/form/captcha.php'.$sn.'" style="border:0px;" /><br />'."\n";
		$str .= '<input id="tpln_captcha" name="tpln_captcha" type="text" maxlength="5" />';
		
		return $str;
	}
	
	function _delCaptcha()
	{
		if(!isset($_SESSION))return;
		
		$sn = session_name();
		if($sn == 'PHPSESSID')$sn = '';		
		if(empty($sn))
		{
			unset($_SESSION['tpln_captcha']);
			unset($_SESSION['tpln_captcha_nb']);
		}
		else
		{
			unset($_SESSION[$sn]['tpln_captcha']);
			unset($_SESSION[$sn]['tpln_captcha_nb']);
		}		
	}
	
	var $captcha_max = 3;
	function setCaptchaMax($nb)
	{
		$this->captcha_max = $nb;
	}
	
	function generateCaptcha()
	{
		$sn = session_name();
		if($sn == 'PHPSESSID')$sn = '';
		
		if(empty($sn))
		{
			$_SESSION['tpln_captcha'] = substr(md5(uniqid(time())), 0, 5);
			if(!isset($_SESSION['tpln_captcha_nb']))
				$_SESSION['tpln_captcha_nb'] = 0;
			else
				$_SESSION['tpln_captcha_nb']++;
			
			if($_SESSION['tpln_captcha_nb'] == $this->captcha_max)
			{
				unset($_SESSION['tpln_captcha']);
				unset($_SESSION['tpln_captcha_nb']);
				die('Error: You can not publish more than '.$this->captcha_max.' times');
			}
		}
		else
		{
			$_SESSION[$sn]['tpln_captcha'] = substr(md5(uniqid(time())), 0, 5);
			if(!isset($_SESSION[$sn]['tpln_captcha_nb']))
				$_SESSION[$sn]['tpln_captcha_nb'] = 0;
			else
				$_SESSION[$sn]['tpln_captcha_nb']++;
			
			if($_SESSION[$sn]['tpln_captcha_nb'] == $this->captcha_max)
			{
				unset($_SESSION[$sn]['tpln_captcha']);
				unset($_SESSION[$sn]['tpln_captcha_nb']);
				die('Error: You can not publish more than '.$this->captcha_max.' times');
			}
		}
	}
	
	function autoVerifyCaptcha()
	{
		$obj = 'tpln_captcha';
		
		// Vrifie si l'obj est pass en parametre, par defaut ou manquant
		if(!$this->rules($obj)) return;
		
		$sn = session_name();
		if($sn == 'PHPSESSID')$sn = '';		
		if(empty($sn))
			$session_tpln_captcha = $_SESSION['tpln_captcha'];
		else
			$session_tpln_captcha = $_SESSION[$sn]['tpln_captcha'];			
		
		if(strcmp($session_tpln_captcha, $_POST['tpln_captcha']) != 0)
		{
			if($this->formErrorLang == 'fr')
				$msg = "Le code de scurit n'est pas valide";
			else
				$msg = "Your security code is not valid";
			
			$this->msg_err[] = $msg;
			$this->objErrorMsg[$this->last_obj][] = $msg;
		}
		
		$this->generateCaptcha(); // on force la generation du captcha
		$_POST['tpln_captcha'] = ''; // on efface le champs
	}
	
}

?>